<?php
namespace Claromentis\Search;

$GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"] ?: array()) + array("_6fd29f1ce82d5e2d09a2d" . "806c2e2b1d5" => base64_decode("aXNfY2Fs" . "bGFibGU="), "_8f7dd777fdeec" . "4a63087bff8b5c" . "757bf" => base64_decode("VW5zdXBwb3J0ZWQgb2JqZWN0IH" . "R5cGUgLSA="), "_5306cb5e8985" . "434a2a638b90f" . "897940d" => base64_decode("IGlzIG5vd" . "CBjYWxsYW" . "JsZQ=="), "_f73dab606630b38" . "8645c4f7d3fbb13b" . "b" => base64_decode("YXJyYXl" . "fbWVyZ2" . "U="), "_c8d1809bdc783b9698" . "165309fe704327" => base64_decode("VGhlIHNlY29uZCBwYXJhbWV0ZXIgb2Y" . "g"), "_d706c160e45bf7" . "434fff82a5976f0" . "e19" => base64_decode("YXJyYXlf" . "a2V5cw=="), "_075c6c4172eaf58cfa84828" . "a3582d19a" => base64_decode("YXJyYXlf" . "dW5pcXVl"));
use Claromentis\Search\Exception\UnsupportedItemTypeException;
use ErrorHandler;
use Exception;
use Claromentis\Search\Indexing\Exception\IndexingException;




class ItemTypeFactory extends ErrorHandler
{
    
    
    
    
    protected $search_item_types = array();
    
    
    
    
    protected $indexing_types = array();
    
    
    
    
    
    
    public function __construct()
    {
        $_a56d3cb9419f5f513e6d57bbcaaf3397 = new Config\Applications();
        $_f3e72c5e54a6dd0fb5c5005cd9574e42 = $_a56d3cb9419f5f513e6d57bbcaaf3397->GetAll();
        foreach ($_f3e72c5e54a6dd0fb5c5005cd9574e42 as $_f44467aacb8a4520c7382769d24aa422) {
            $this->RegisterApplication($_f44467aacb8a4520c7382769d24aa422);
        }
        
        
        
        
        
        
        
        
        \ClaPlugins::I()->RegisterIndexingObjectType($this);
    }
    
    
    
    
    
    
    public function RegisterApplication(Application\ApplicationInterface $_f44467aacb8a4520c7382769d24aa422)
    {
        $_17728688d370dbb69c53d9e641c4b0e0 = $_f44467aacb8a4520c7382769d24aa422->GetTypes();
        foreach ($_17728688d370dbb69c53d9e641c4b0e0 as $type => $_ef7e3c851590d142b4d780e7b9043897) {
            $this->RegisterType($type, $_ef7e3c851590d142b4d780e7b9043897);
        }
    }
    
    
    
    
    
    
    
    public function RegisterType($type, $_06e5839e14e1bc203f750e67ef402284)
    {
        if (!$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_6fd29f1" . "ce82d5e2" . "d09a2d80" . "6c2e2b1d" . "5"]($_06e5839e14e1bc203f750e67ef402284)) {
            throw new IndexingException($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_c8d1809bdc783b9698165309fe70" . "4327"] . __METHOD__ . $GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_5306cb5e8985434a2a6" . "38b90f897940d"], 1);
        }
        $this->search_item_types[$type] = $_06e5839e14e1bc203f750e67ef402284;
    }
    
    
    
    
    
    
    
    public function Get($type)
    {
        if (isset($this->search_item_types[$type])) {
            return $this->search_item_types[$type]();
        } else {
            $e = new UnsupportedItemTypeException($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_8f7dd777fdeec4a63087bff" . "8b5c757bf"] . $type);
            $e->item_type = $type;
            throw $e;
        }
    }
    
    
    
    
    
    
    public function GetAllIndexingTypes()
    {
        return $GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_075c6c4172eaf58c" . "fa84828a3582d19a"]($GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_f73dab606630b388645c4f7d3" . "fbb13bb"]($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_d706c160e45" . "bf7434fff82a" . "5976f0e19"]($this->search_item_types), $GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_d706c160e45bf7434fff82a" . "5976f0e19"]($this->indexing_types)));
    }
    
    
    
    
    
    
    
    public function RegisterIndexingType($_90a9b1825557bb7e0aff3dc1a7962296, $_06e5839e14e1bc203f750e67ef402284)
    {
        if (!$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_6fd29f1ce82d5e2d" . "09a2d806c2e2b1d5"]($_06e5839e14e1bc203f750e67ef402284)) {
            throw new IndexingException($GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_c8d1809bdc783b9" . "698165309fe70432" . "7"] . __METHOD__ . $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_5306cb5e8985434a2a" . "638b90f897940d"], 1);
        }
        $this->indexing_types[$_90a9b1825557bb7e0aff3dc1a7962296] = $_06e5839e14e1bc203f750e67ef402284;
    }
    
    
    
    
    
    
    public function GetIndexingObject($type)
    {
        if (isset($this->indexing_types[$type])) {
            $_68ffaaa31e3ba49ed9d6159fbee9f043 = $this->indexing_types[$type]();
            return $_68ffaaa31e3ba49ed9d6159fbee9f043;
        } else {
            return $this->Get($type)->GetIndexingObject();
        }
    }
}